<script lang="ts">
  import moment from 'moment';
  import { TabContent, Table, TabPane } from '@sveltestrap/sveltestrap';
  import { onMount } from 'svelte';
  import { eventId } from '@stores';
  import { GetAllTeams, type Team } from '@models/Team';
  import type { ChallengeWithSolves } from '@models/Challenges';
  import { ChallengeWithSolvesQuery } from '@models/Challenges';
  import { EventRole } from '@auth/models';
  import { Gql } from '@db';

  let teams: Team[] = [];
  let selectedTeam: Team | null = null;
  // All challenges and solves for all teams
  let challenges: ChallengeWithSolves[] = [];
  // challenges the selectedTeam has solved
  let teamSolves: ChallengeWithSolves[] = [];
  $: if (selectedTeam) {
    // filter solves data by the currently selected team
    teamSolves = challenges.filter((challenge) => challenge.solves.some(({ team_id }) => team_id === selectedTeam?.id));
  }

  onMount(async () => {
    teams = await GetAllTeams($eventId);
    Gql.subscribeSimple<{ challenges_challenges: ChallengeWithSolves[] }>(
      `subscription ${ChallengeWithSolvesQuery($eventId)}`,
      (value) => (challenges = value.challenges_challenges),
      { queryRole: EventRole.CTFAdmin },
    );
  });
</script>

<div>
  <TabContent class="align-self-center" on:tab={(e) => (selectedTeam = e.detail)} pills>
    {#each teams as team, i}
      <TabPane tabId={team} tab={team.name} active={i === 0} />
    {/each}
  </TabContent>
  <h5 class="align-self-center">{`Total Solves ${teamSolves.length}`}</h5>
  <Table class="text-white">
    <thead>
      <tr>
        <th>Name</th>
        <th>Category</th>
        <th>Points</th>
        <th>Timestamp</th>
      </tr>
    </thead>
    <tbody>
      {#each teamSolves as chal}
        <tr>
          <td>{chal.name}</td>
          <td>{chal.category}</td>
          <td>{chal.active?.[0]?.points}</td>
          <td>
            {moment(chal.solves.find((sol) => sol.team_id === selectedTeam.id)?.time || '').format('LT')}
          </td>
        </tr>
      {/each}
    </tbody>
  </Table>
</div>
